unit to8c8snd;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, vfw, math, mmsystem;

const
// :
//0..54,55..109 as $01..$37,$41..$77 - attr & nonstandard chr
//110..164,165..219 as $01..$37,$41..$77 - attr & standard chr
//220..255 - skips(1..36)+219

//  b/w:
//0..84 -  0..84 ,  - 
//85..169 -  0..84 ,  - 
//170..254 -  0..84 ,  - 0-  ()
//255 -  
mosts=256{544};
baseskip=219;
//maxrep=68;
frqcoef=17500{18020.329}{19269}/44100;
sectcycl=8{8};
               // frqcoef=17500  sectcycl=8  maxchs=338  fps=10
                                                       //maxchs=225  fps=15
                                                       //maxchs=169  fps=20
                                                       //maxchs=141  fps=24
                                                       //maxchs=135  fps=25
                                                       //maxchs=113  fps=30
mywritebufsz=100000;
myreadbufsz=1000000;

// kb=0.5;
// kg=1.5;
 zro={-10}0;
 b75={70}63;
 b127={137}126;
// b0=0;b1=b75;b2=b127;b3=b127+b75;b4=b127+b127;
// bdiv=60;{       0..4}
 brb:array[0..15]of integer=(zro,b75,zro,b75,zro,b75,zro,b75,zro,b127,zro,b127,zro,b127,zro,b127);
 brg:array[0..15]of integer=(zro,zro,zro,zro,b75,b75,b75,b75,zro,zro,zro,zro,b127,b127,b127,b127);
 brr:array[0..15]of integer=(zro,zro,b75,b75,zro,zro,b75,b75,zro,zro,b127,b127,zro,zro,b127,b127);
 brb2:array[0..15]of integer=(zro,b75,zro,b75,zro,b75,zro,b75,zro,b127*2,zro,b127*2,zro,b127*2,zro,b127*2);
 brg2:array[0..15]of integer=(zro,zro,zro,zro,b75,b75,b75,b75,zro,zro,zro,zro,b127*2,b127*2,b127*2,b127*2);
 brr2:array[0..15]of integer=(zro,zro,b75,b75,zro,zro,b75,b75,zro,zro,b127*2,b127*2,zro,zro,b127*2,b127*2);
 bestcolor:array[0..3{g},0..3{r},0..3{b}]of byte=(
     {r=0}           {r=1}         {r=2}         {r=3}
 (($0,$1,$1,$9),($2,$3,$3,$9),($2,$3,$3,$b),($a,$a,$b,$b)),{g=0}
 (($4,$5,$5,$5),($6,$7,$7,$7),($6,$7,$7,$7),($a,$a,$b,$b)),{g=1}
 (($4,$5,$5,$d),($6,$7,$7,$d),($6,$7,$7,$f),($e,$e,$f,$f)),{g=2}
 (($c,$c,$d,$d),($c,$c,$d,$d),($e,$e,$f,$f),($e,$e,$f,$f)) {g=3}
 );
//     chtab:
//4 2
//1 3
//   (x<--->y):
//4 1
//2 3
 chtab:array[0..7,0..7]of byte=(
        ($26,$A6,$06,$86,$2A,$AA,$0A,$8A),
        ($E6,$66,$C6,$46,$EA,$6A,$CA,$4A),
        ($16,$96,$36,$B6,$1A,$9A,$3A,$BA),
        ($D6,$56,$F6,$76,$DA,$5A,$FA,$7A),
        ($2E,$AE,$0E,$8E,$22,$A2,$02,$82),
        ($EE,$6E,$CE,$4E,$E2,$62,$C2,$42),
        ($1E,$9E,$3E,$BE,$12,$92,$32,$B2),
        ($DE,$5E,$FE,$7E,$D2,$52,$F2,$72));

type
  TForm1 = class(TForm)
    edSat1: TEdit;
    Image4: TImage;
    Timer1: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    EditG: TEdit;
    EditB: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    btStart: TButton;
    lbFrame: TLabel;
    edBri1: TEdit;
    edCon1: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    Label9: TLabel;
    edFrme: TEdit;
    Label10: TLabel;
    edFrmStep: TEdit;
    Label11: TLabel;
    edFrmb: TEdit;
    btStop: TButton;
    Label6: TLabel;
    edStandartize: TEdit;
    Label12: TLabel;
    edBadErrorLevel: TEdit;
    edPath: TEdit;
    Label13: TLabel;
    btApplyPath: TButton;
    Label14: TLabel;
    edDith: TEdit;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label3: TLabel;
    EditR: TEdit;
    Label18: TLabel;
    edXmin: TEdit;
    Label19: TLabel;
    edXmax: TEdit;
    Label20: TLabel;
    edYmin: TEdit;
    Label21: TLabel;
    edYmax: TEdit;
    Label22: TLabel;
    edStErrorLevel: TEdit;
    Label23: TLabel;
    edGoodErrorLevel: TEdit;
    Label24: TLabel;
    edBadDelay: TEdit;
    Label25: TLabel;
    edGoodDelay: TEdit;
    edPixelsDelay: TEdit;
    Label27: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label28: TLabel;
    Label26: TLabel;
    Image2: TImage;
    Image1: TImage;
    rgBright: TRadioGroup;
    cb16: TCheckBox;
    edFramewait: TEdit;
    edMaxChrs: TEdit;
    edMaxLaces: TEdit;
    edWAV: TEdit;
    Label31: TLabel;
    edCifr: TEdit;
    cbVIsual: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure edFrmStepChange_pp;
    procedure edSat1Change_pp;
    procedure edSat1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure openfiles;
    procedure closefiles;
    procedure view;
    procedure init;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btStartClick(Sender: TObject);
    procedure edPathChange(Sender: TObject);
    procedure btApplyPathClick(Sender: TObject);
    procedure edPathKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edFrmStepChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  no,fr,realfr:integer;
  scr0,scr1,bmp,bmpin:tBitmap;
  bitmas:array[0..255]of byte; //    
  chr:array[0..7]of byte;
  most:array[0..600{mosts-1},0..8]of byte;
  mostuse:array[0..600{mosts-1}]of integer;
 holesstat:array[0..255]of longint;
  mem,chs,sts,reps,repatr,emptys:integer;
  old,old1,oldatr,oldatr2:array[0..23,0..31]of integer;
  fbit,fbyte,fstand,fatr,fsa,fwav:file;
  making,alwaysgood,alwayschanged,frameexist:boolean;
  con1,bri1,sat1,perc:real;
  frmb,frme,frmstep:integer;
  standartize:integer; // ...    
  sterrorlevel:integer; // standards,     ... B+R+2G     
  baderrorlevel:integer; //,     ... B+R+2G     
  gooderrorlevel:integer; //-''-  
  baddelay,gooddelay,pixelsdelay:integer;
  n0,n255:byte;
  miny,maxy,minx,maxx:integer;
  code256:array[0..624]of byte;
  deco256:array[0..511]of byte;
  files:string;
  oldbx,oldgx,oldrx,oldbx1,oldgx1,oldrx1,bx,gx,rx:array[-1..257,-1..257]of integer; //old* -   CHR; bx,rx,gx -    
  presave:array[0..32767]of byte; //  16col  
  sortpointer:array[0..2000]of integer; //     presave
  sortdif,wassortdif:array[0..2000]of integer; //,   
  curquant:real;
  mywritebuf:array[0..mywritebufsz-1]of byte;
  myreadbuf:array[0..myreadbufsz-1]of smallint;
  mywritebufpointer,myreadbufpointer:integer;
  pixtime,conversiontime,filetime,temptime,temptime2,componentstime,visualtime,britime:integer;
  wreadbuf,oldwreadbuf:array[0..1]of smallint;

implementation

{$R *.DFM}

procedure myblockread(var fwav:file;var perem:smallint);
var
 i:integer;
begin
 if myreadbufpointer>=myreadbufsz
 then begin
  for i:=0 to myreadbufsz-1 do myreadbuf[i]:=0;
  if not eof(fwav) then blockread(fwav,myreadbuf,myreadbufsz*2);
  myreadbufpointer:=0;
 end;
 perem:=myreadbuf[myreadbufpointer];
 inc(myreadbufpointer);
end;

function wlockread(var fwav:file):byte;
begin
 while curquant<1.0 do begin
  curquant:=curquant+frqcoef;
  oldwreadbuf:=wreadbuf;
  myblockread(fwav,wreadbuf[0]);
  myblockread(fwav,wreadbuf[1]);
 end;
 curquant:=curquant-1.0;
// wlockread:=trunc(((wreadbuf[0]+wreadbuf[1])/512)+128);
 wlockread:=trunc(
                 (oldwreadbuf[0]+oldwreadbuf[1])*(1-curquant)
                +(   wreadbuf[0]+   wreadbuf[1])*curquant
                 )div 512+128;
end;

function hexdig(i:byte):char;
begin
 if i<10
 then hexdig:=char(i+48)
 else hexdig:=char(i+87);
end;

function inttohex(i:integer):string;
begin
 inttohex:=hexdig(i div 16)+hexdig(i and 15)
end;

function min2i(x,y:byte):byte;
begin
//ord?
 if x<y then min2i:=x else min2i:=y;
end;

function max2i(x,y:byte):byte;
begin
 if x>y then max2i:=x else max2i:=y;
end;

function mi5i(a0,a1,a2,a3,a4:integer):integer;
var m:integer;
begin
 if a1<a0 then m:=a1 else m:=a0;
 if a2<m then m:=a2;
 if a3<m then m:=a3;
 if a4<m then mi5i:=a4 else mi5i:=m;
end;

function byter(x:real):byte;
begin
 if x<0 then byter:=0
 else if x>255 then byter:=255
 else byter:=trunc(x)
end;

function ver(x:real):real;
begin
 if x>0 then ver:=x*5
 else ver:=x;
end;

procedure TForm1.init;
var
 i,j:integer;
begin
 for j:=miny to maxy do
  for i:=minx to maxx do begin
   old[j,i]:=-100;
   old1[j,i]:=-100;
   oldatr[j,i]:=-100;
   oldatr2[j,i]:=-100;
  end;
 fr:=0; realfr:=0; no:=frmb;
 chs:=0; sts:=0; emptys:=0;
 alwaysgood:=false;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
 n,bb:byte;
 i,j,k,pix,piy,ij:integer;
 most256:tbitmap;
 myrect:trect;
begin
 files:=edPath.Text;
 maxx:=31;maxy:=23;
 assignfile(fsa,'code256.dat');reset(fsa,1);
 blockread(fsa,code256,625);
 closefile(fsa);
 assignfile(fsa,'deco256.dat');reset(fsa,1);
 blockread(fsa,deco256,512);
 closefile(fsa);
 for i:=0 to 255 do begin
   bb:=i; bitmas[i]:=0;
   for n:=0 to 7 do begin
    inc(bitmas[i],bb and 1);
    bb:=bb shr 1;
   end;
 end;
 bmpin:=tBitmap.Create;
 bmp:=tBitmap.Create;
 bmp.pixelformat:=pf24bit;
 bmp.Width:=256; bmp.Height:=192;
 bmpin.Canvas.Brush.Color:=0;
 image2.Picture.Bitmap:=tbitmap.Create;
 image2.Picture.Bitmap.pixelformat:=pf24bit;
 image2.Picture.Bitmap.Width:=256; image2.Picture.Bitmap.Height:=192;

 scr0:=tBitmap.Create;
 scr0.pixelformat:=pf24bit;
 scr0.width:=256; scr0.height:=192;
 scr1:=tBitmap.Create;
 scr1.pixelformat:=pf24bit;
 scr1.width:=256; scr1.height:=192;

 most256:=tBitmap.Create;
 most256.LoadFromFile('256most!.bmp');
 image1.Picture.Bitmap:=tbitmap.Create;
 image1.Picture.Bitmap.pixelformat:=pf24bit;
 image1.Picture.Bitmap.Width:=most256.Width;
 image1.Picture.Bitmap.Height:=most256.Height;
 MyRect := Rect(0,0,most256.Width,most256.Height);
 image1.Picture.bitmap.canvas.copyrect(MyRect,most256.Canvas,MyRect);
 for j:=0 to 31 do
  for i:=0 to 15{16} do
   for piy:=0 to 3 do begin
    ij:=j*16{17}+i;
    most[ij,piy*2]:=0;
    most[ij,piy*2+1]:=0;
    for pix:=0 to 3 do begin
     k:=(most256.Canvas.Pixels[j*5+pix,i*5+piy]and 255) div 63;
     most[ij,piy*2]:=most[ij,piy*2]shl 2+2*ord(k>3)+ord(k>0);
     most[ij,piy*2+1]:=most[ij,piy*2+1]shl 2+2*ord(k>1)+ord(k>2);
    end;
    mostuse[ij]:=0;
   end;

 edSat1Change_pp;
 edFrmStepChange_pp;
 btApplyPathClick(Sender);
end;

procedure bytewrite(perem:byte);
begin
 mywritebuf[mywritebufpointer]:=perem;
 inc(mywritebufpointer);
 inc(mem);
{ if(mywritebufpointer>=mywritebufsz)
 then begin
  mywritebufpointer:=0;
  myflush;
 end;}
end;

procedure myflush;
begin
 blockwrite(fbyte,mywritebuf,mywritebufpointer);
end;

procedure attrwrite(num:byte);
//var
// d:byte;
begin
//  RLE -    8- ,
//  M,M,len - 
//RLE ,   ,   
//(  )
{ if reps=0 then begin blockwrite(fatr,num,1);inc(mem);reps:=1 end
 else
  if num=repatr
  then begin
    inc(reps);
    if reps=maxrep
    then begin d:=reps+$75;blockwrite(fatr,d,1);inc(mem);reps:=0 end;
  end
  else begin
    if reps>2
    then begin d:=reps+$75;blockwrite(fatr,d,1);inc(mem);reps:=0 end
    else if reps=2
    then begin blockwrite(fatr,repatr,1);inc(mem);reps:=0 end;{}
    blockwrite(fatr,num,1);inc(mem);reps:=1
{ end;
 repatr:=num{}
end;

procedure attrnowrite;
var d:byte;
begin
 if reps>2
 then begin d:=reps+$75;blockwrite(fatr,d,1);inc(mem);reps:=0 end
 else if reps=2
 then begin blockwrite(fatr,repatr,1);inc(mem);reps:=0 end;
end;

{************************************************************************}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure TForm1.view;
var
 tvid_tsnd:real;
 rreal:real;
 code:integer;
 writeatr,writestand,c16on,wr1st_chr_of_frame:boolean;
 dfrwait:byte;
 oldtime:integer;
 chrx,chry{CHRs},i,j{in chr},x,y{full coords}:integer;
 p,p0,pin:pbytearray;
 pinptr:integer;
 atr:array[0..23,0..31]of byte;
 bs,gs,rs,ms:array[0..7,0..7]of byte;
 ercol0,mindif,loopi,loopn:integer;
 dif,dif0,newdif,curnewdif,curdelay:integer;
 bdith,gdith,rdith,cb,cg,cr:integer;
 bronly0,bronly1,b1,i1,i2,mini1,mini2,m:byte;
 cont,bri,light:real;
 contint,briint,lightint,satint:integer;
 r,g,b:byte;
 rint,gint,bint,midr,midg,midb:integer;
 kint,k2int:integer;
 db,dr,dg,adr,jr,emptycount:integer;
 otn1,otn2,_a,_b,_a2,_b2,_c2,_ax,_bx:real;
 a_b,a_g,a_r:array[0..4]of integer;
 pixcol:tcolor;
 gdechr:integer;
 maxskip:byte;
 maxchrs,curmaxchrs,chsinthisframe,maxlaces,bplane:integer;
 bytemas:array[0..100]of byte;
 ppresave:integer; //  . .  presave
 psort:integer; //  . .  sort* (   = - )
 filenamestring:string;
 bmpscanline,scr0scanline,bmpinscanline:array[0..255]of pbytearray;
begin
 making:=true;

 oldtime:=timeGetTime;
 mywritebufpointer:=0;
 ppresave:=0; psort:=0;
 reps:=0; //   attrwrite
temptime:=timegettime;
 c16on:=cb16.Checked;
 try db:=strtoint(EditB.text);except db:=0;end;
 try dr:=strtoint(EditR.text);except dr:=0;end;
 try dg:=strtoint(EditG.text);except dg:=0;end;
 try dfrwait:=strtoint(edFrameWait.text);except dfrwait:=0;end;
 try maxchrs:=strtoint(edMaxChrs.text);except maxchrs:=0;end;
 try maxlaces:=strtoint(edMaxLaces.text);except maxlaces:=0;end;
 case rgBright.ItemIndex of
  0:   begin bronly0:=0;bronly1:=0;maxskip:=36;end;
  1:   begin bronly0:=1;bronly1:=1;maxskip:=36;end;
  3:   begin bronly0:=1;bronly1:=0;maxskip:=84;end;
  else begin bronly0:=0;bronly1:=1;maxskip:=36;end;
 end;
visualtime:=visualtime+timegettime-temptime;
temptime:=timegettime;
 if edCifr.Text='3'
 then
 filenamestring:=files
   +inttostr(no div 100)
   +inttostr((no mod 100)div 10)
   +inttostr(no mod 10)
   +'.bmp';
 if edCifr.Text='4'
 then
 filenamestring:=files
   +inttostr(no div 1000)
   +inttostr((no mod 1000)div 100)
   +inttostr((no mod 100)div 10)
   +inttostr(no mod 10)
   +'.bmp';
 if edCifr.Text='5'
 then
 filenamestring:=files
   +inttostr(no div 10000)
   +inttostr((no mod 10000)div 1000)
   +inttostr((no mod 1000)div 100)
   +inttostr((no mod 100)div 10)
   +inttostr(no mod 10)
   +'.bmp';
 if edCifr.Text='6'
 then
 filenamestring:=files
   +inttostr(no div 100000)
   +inttostr((no mod 100000)div 1000)
   +inttostr((no mod 10000)div 1000)
   +inttostr((no mod 1000)div 100)
   +inttostr((no mod 100)div 10)
   +inttostr(no mod 10)
   +'.bmp';
visualtime:=visualtime+timegettime-temptime;
 if FileExists(filenamestring)
 then begin
 temptime:=timegettime;
   bmpin.LoadFromFile(filenamestring);
   bmpin.height:=192;bmpin.width:=256;{bmp.PixelFormat:=pf24bit;}
   if cbVisual.Checked then image2.picture.Assign(bmpin);
 visualtime:=visualtime+timegettime-temptime;
   cont:=con1; bri:=(bri1*256)-128*(con1-1);
 contint:=trunc(cont*256);
 briint:=trunc(bri*256);
 satint:=trunc(sat1*256);

 temptime:=timegettime;
 for j:=0 to 191 do begin
  bmpscanline[j]:=bmp.ScanLine[j];
  scr0scanline[j]:=scr0.ScanLine[j];
  bmpinscanline[j]:=bmpin.ScanLine[j];
 end;
 componentstime:=componentstime+timegettime-temptime;

 temptime2:=timegettime;
   for chrx:=minx{0} to maxx{31} do for chry:=miny{0} to maxy{23} do begin
    for j:=0 to 7 do begin
     y:=chry*8+j;
     p:=bmpScanLine[y];
     pin:=bmpinScanLine[y];
     pinptr:=(chrx shl 3)*3;
     adr:=chrx*24;
     for i:=0 to 7 do begin
      bint:=pin[pinptr]*contint+briint;
      inc(pinptr);
      gint:=pin[pinptr]*contint+briint;
      inc(pinptr);
      rint:=Pin[pinptr]*contint+briint;
      inc(pinptr);
      lightint:=(38*bint+77*rint+141*gint)div 256;
      bint:=(((bint-lightint)*satint)div 256+lightint+db)div 256;
      if bint<0 then b:=0 else if bint>255 then b:=255 else b:=bint;
      gint:=(((gint-lightint)*satint)div 256+lightint+dg)div 256;
      if gint<0 then g:=0 else if gint>255 then g:=255 else g:=gint;
      rint:=(((rint-lightint)*satint)div 256+lightint+dr)div 256;
      if rint<0 then r:=0 else if rint>255 then r:=255 else r:=rint;
      p[adr]:=b; bs[j,i]:=b; bx[chry shl 3+j,chrx shl 3+i]:=b;
      inc(adr);
      p[adr]:=g; gs[j,i]:=g; gx[chry shl 3+j,chrx shl 3+i]:=g;
      inc(adr);
      p[adr]:=r; rs[j,i]:=r; rx[chry shl 3+j,chrx shl 3+i]:=r;
      inc(adr);
     end; //i
    end; //j
    if not c16on then begin // 
      mindif:=MaxInt; mini2:=7; mini1:=0;
      for b1:=bronly0{0} to bronly1{1} do for i1:=b1 shl 3 to b1 shl 3+6 do for i2:=i1+1 to b1 shl 3+7 do
       if ((i1 xor i2)<>1)and not(
                                    (((i1 and 7)<>0)and(((i1 or i2)and 7)=7))
                                  or(((i1 and 7)=2)and((i2 and 7)=4))
                                 )
       then begin
        a_b[0]:=brb2[i1];a_g[0]:=brg2[i1];a_r[0]:=brr2[i1];
        a_b[1]:=brb2[i2];a_g[1]:=brg2[i2];a_r[1]:=brr2[i2];
        a_b[2]:=brb[i1]+brb[i2];a_g[2]:=brg[i1]+brg[i2];a_r[2]:=brr[i1]+brr[i2];
        a_b[3]:=(a_b[0]+a_b[2])shr 1;a_g[3]:=(a_g[0]+a_g[2])shr 1;a_r[3]:=(a_r[0]+a_r[2])shr 1;
        a_b[4]:=(a_b[1]+a_b[2])shr 1;a_g[4]:=(a_g[1]+a_g[2])shr 1;a_r[4]:=(a_r[1]+a_r[2])shr 1;
        ercol0:=0;
        for i:=0 to 7 do for j:=0 to 7 do begin
         cb:=bs[j,i];cg:=gs[j,i];cr:=rs[j,i];
         inc(ercol0,mi5i(
           {kb*}sqr(a_b[0]-cb)+{kg*}sqr(a_g[0]-cg)+sqr(a_r[0]-cr),
           {kb*}sqr(a_b[1]-cb)+{kg*}sqr(a_g[1]-cg)+sqr(a_r[1]-cr),
           {kb*}sqr(a_b[2]-cb)+{kg*}sqr(a_g[2]-cg)+sqr(a_r[2]-cr),
           {kb*}sqr(a_b[3]-cb)+{kg*}sqr(a_g[3]-cg)+sqr(a_r[3]-cr),
           {kb*}sqr(a_b[4]-cb)+{kg*}sqr(a_g[4]-cg)+sqr(a_r[4]-cr)));
         if ercol0>mindif then break;
        end; //ij
        if ercol0<mindif then begin mindif:=ercol0;mini1:=i1;mini2:=i2;end;
       end; //if, i2i1b1
      atr[chry,chrx]:=(mini2 and 7+mini1 shl 3);
    end; // 
   end; //yx
 britime:=britime+timegettime-temptime2;

// Memo1.Lines.Add('array.time='+IntToStr(timeGetTime-oldtime));
// oldtime:=timeGetTime;

 temptime2:=timegettime;
   emptycount:=0;
   for chrx:=minx{0} to maxx{31} do for chry:=miny{0} to maxy{23} do begin
     dif:=0;
     mini1:=atr[chry,chrx]and 7+(atr[chry,chrx]and 64)shr 3; mini2:=atr[chry,chrx]shr 3;
 {pap}a_b[0]:=brb2[mini2];a_g[0]:=brg2[mini2];a_r[0]:=brr2[mini2];
 {ink}a_b[1]:=brb2[mini1];a_g[1]:=brg2[mini1];a_r[1]:=brr2[mini1];
     for j:=0 to 7 do begin
// temptime:=timegettime;
       p:=bmpScanLine[chry*8+j];
       p0:=scr0ScanLine[chry*8+j];
// componentstime:=componentstime+timegettime-temptime;
       for i:=0 to 7 do begin
        adr:=chrx*24+i*3;
        bdith:=p[adr];gdith:=p[adr+1];rdith:=p[adr+2];
        if not c16on then begin
    {pap} otn1:=sqr(a_b[0]-bdith)+sqr(a_g[0]-gdith)+sqr(a_r[0]-rdith);
    {ink} otn2:=sqr(a_b[1]-bdith)+sqr(a_g[1]-gdith)+sqr(a_r[1]-rdith);
          //     (?),    
          _c2:=sqr(a_b[1]-a_b[0])+sqr(a_g[1]-a_g[0])+sqr(a_r[1]-a_r[0]);
          _a2:=otn1/_c2;_b2:=otn2/_c2;
          _a:=sqrt(_a2);_b:=sqrt(_b2);
          if _a2+1-_b2<>0 then _ax:=2*_a/(_a2+1-_b2) else _ax:=-1e9;
          if _b2+1-_a2<>0 then _bx:=2*_a/(_b2+1-_a2) else _bx:=-1e9;
          if _ax+_bx>0 then otn1:=255*_ax/(_ax+_bx)else if otn1<otn2 then otn1:=255 else otn1:=0;{!}
          //------------------------------------------------------------------
          mini1:=ord(otn1<min2i(max2i(chtab[i and 3,j and 3],n0),n255));
          chr[j]:=chr[j]shl 1+mini1;
          b:=a_b[mini1];g:=a_g[mini1];r:=a_r[mini1];
          if({255*ord(}p0[adr]{>0)}<>b)then inc(dif);
          if({255*ord(}p0[adr+1]{>0)}<>g)then inc(dif,2);
          if({255*ord(}p0[adr+2]{>0)}<>r)then inc(dif);
          p[adr]:=b; p[adr+1]:=g; p[adr+2]:=r; // 0, 63,126
        end //not c16on
        else begin //c16on
          y:=chry*8+j; x:=chrx*8+i;
          cb:=bx[y,x];cg:=gx[y,x];cr:=rx[y,x];
          //-           ,
          //   RGB   (oldbx)  RGB   (*dith)!
          inc(dif,sqr(oldbx[y,x]-bdith){*2} + sqr(oldgx[y,x]-gdith){*3} + sqr(oldrx[y,x]-rdith){*2});
          bs[j,i]:=bdith; gs[j,i]:=gdith; rs[j,i]:=rdith;
          if cb>255 then cb:=255;if cg>255 then cg:=255;if cr>255 then cr:=255;
          if cb<0 then cb:=0;if cg<0 then cg:=0;if cr<0 then cr:=0;
(*          kint:=MaxInt;
          for loopi:=1 to 15 do begin
           k2int:=sqr(brg2[loopi]-cg){*3} + sqr(brr2[loopi]-cr){*2} + sqr(brb2[loopi]-cb){*2};
           if k2int<kint then begin kint:=k2int;mini1:=loopi end;
          end;*)
          mini1:=bestcolor[cg div 64,cr div 64,cb div 64];
          ms[j,i]:=mini1;
          cb:=cb-brb2[mini1];cg:=cg-brg2[mini1];cr:=cr-brr2[mini1];
          bx[y,x+1]:=bx[y,x+1]+cb div 2;gx[y,x+1]:=gx[y,x+1]+cg div 2;rx[y,x+1]:=rx[y,x+1]+cr div 2;
          bx[y+1,x]:=bx[y+1,x]+cb div 4;gx[y+1,x]:=gx[y+1,x]+cg div 4;rx[y+1,x]:=rx[y+1,x]+cr div 4;
          bx[y+1,x-1]:=bx[y+1,x-1]+cb div 8;gx[y+1,x-1]:=gx[y+1,x-1]+cg div 8;rx[y+1,x-1]:=rx[y+1,x-1]+cr div 8;
          bx[y+1,x+1]:=bx[y+1,x+1]+cb div 8;gx[y+1,x+1]:=gx[y+1,x+1]+cg div 8;rx[y+1,x+1]:=rx[y+1,x+1]+cr div 8;
          p[adr]:=brb2[mini1]; p[adr+1]:=brg2[mini1]; p[adr+2]:=brr2[mini1];
        end; //c16on
       end; //i
     end; //j

     //      
     if not c16on then begin
      for i:=0 to mosts-1 do begin
       most[i,8]:=0; for j:=0 to 7 do inc(most[i,8],bitmas[chr[j]xor most[i,j]]);
      end;
      newdif:=255;
      for i:=0 to mosts-1 do
       if most[i,8]<newdif then begin newdif:=most[i,8]; dif0:=i; end;
      writestand:=newdif<standartize;
     end //not c16on
     else begin //c16on
      dif:=(dif+49) div 50; // max=10 ,   max=200000
      writestand:=false;
      newdif:=MaxInt;
      midg:=0; midr:=0; midb:=0;
      for j:=0 to 7 do for i:=0 to 7 do begin
       inc(midg,gs[j,i]);
       inc(midr,rs[j,i]);
       inc(midb,bs[j,i]);
      end;
      for loopi:=0 to 15 do
       if (abs(midg-brg2[loopi]*64)<1000)
       and(abs(midr-brr2[loopi]*64)<1000)
       and(abs(midb-brb2[loopi]*64)<1000)
       then begin
         curnewdif:=0;
         for j:=0 to 7 do for i:=0 to 7 do
          inc(curnewdif,sqr(brg2[loopi]-gs[j,i]){*3} + sqr(brr2[loopi]-rs[j,i]){*2} + sqr(brb2[loopi]-bs[j,i]){*2});
         curnewdif:=(curnewdif+49) div 50; // max=10 ,   max=200000
                                             //  div 5000 -     errorlever'    0
         if (curnewdif<standartize)and(curnewdif<newdif)
         then begin dif0:=loopi;writestand:=true;newdif:=curnewdif; end;
       end;
     end;

     //       
     //  ( ..),     emptycount=maxskip!
     if writestand then begin
      writestand:=false; // .  true
      if c16on then begin
        for j:=0 to 7 do for i:=0 to 7 do ms[j,i]:=dif0;
        for j:=0 to 7 do begin
         p:=bmpScanLine[chry*8+j];
         p0:=scr0ScanLine[chry*8+j];
         for i:=0 to 7 do begin
          adr:=chrx*24+i*3;
          if(p0[adr]<>brb2[dif0])or(p0[adr+1]<>brg2[dif0])or(p0[adr+2]<>brr2[dif0])
          then writestand:=true;
         //  
          p[adr]:=brb2[dif0];p[adr+1]:=brg2[dif0];p[adr+2]:=brr2[dif0];
         end; //i
        end; //j
      end //c16on
      else begin //not c16on
        for j:=0 to 7 do chr[j]:=most[dif0,j];
        for j:=0 to 7 do begin
         b:=chr[j];
// temptime:=timegettime;
         p:=bmpScanLine[chry*8+j];
         p0:=scr0ScanLine[chry*8+j];
// componentstime:=componentstime+timegettime-temptime;
         for i:=0 to 7 do begin
          adr:=chrx*24+i*3;
          if(p0[adr]<>a_b[b div 128])or(p0[adr+1]<>a_g[b div 128])or(p0[adr+2]<>a_r[b div 128])
          then begin writestand:=true;break;end;
         //  
          p[adr]:=a_b[b div 128];p[adr+1]:=a_g[b div 128];p[adr+2]:=a_r[b div 128];
          b:=b shl 1;
         end; //i
        end; //j
      end; //not c16on
     end; //writestand
 pixtime:=pixtime+timegettime-temptime2;

temptime2:=timegettime;
     writeatr:=false;
     curdelay:=fr-old[chry,chrx];
     if(old[chry,chrx]=-100)
      or(writestand and ((dif>=sterrorlevel){or alwaysgood}))
      or((curdelay>baddelay)and(dif>=baderrorlevel))
      or( ((curdelay>gooddelay){or alwaysgood})and(dif>=gooderrorlevel) )
      or(writestand and(curdelay>pixelsdelay)and(dif>0)and(newdif<dif))
      or((emptycount=maxskip)and(not c16on))
     then begin
      if not c16on then begin
           old[chry,chrx]:=fr;
           for j:=0 to 7 do begin
// temptime:=timegettime;
            p:=bmpScanLine[chry*8+j];
            p0:=scr0ScanLine[chry*8+j];
// componentstime:=componentstime+timegettime-temptime;
            for i:=0 to 23 do p0[chrx*24+i]:=p[chrx*24+i];
           end;
           if(writestand) then begin
            inc(mostuse[dif0]);
            if dif0=0 then atr[chry,chrx]:=7;
            writeatr:=true;
            if not((bronly0>bronly1)and(dif0=0)) then begin
             blockwrite(fstand,dif0,1);
             inc(mem);
             inc(sts);
            end;
           end
           else begin //non-standart chr$
            writeatr:=true;
            for j:=0 to 3 do begin
             jr:=0; m:=128;
             for i:=0 to 3 do begin
              jr:=jr*5;
              if (chr[j+j]and m)<>0 then inc(jr);
              if (chr[j+j+1]and m)<>0 then inc(jr);
              m:=m shr 1;
              if (chr[j+j]and m)<>0 then inc(jr);
              if (chr[j+j+1]and m)<>0 then inc(jr);
              m:=m shr 1;
             end; //i
             bytewrite(code256[jr]);
            end; //j
            inc(chs);
           end; //non-standart chr$
           oldatr[chry,chrx]:=atr[chry,chrx];
           if(bronly0>bronly1) then begin
            inc(holesstat[emptycount]);
            if(writestand)then if(dif0=0)then dif:=170+emptycount else dif:=85+emptycount
            else dif:=emptycount;
            attrwrite(dif);
           end ///    
           else begin
            if emptycount>0 then begin
             inc(holesstat[emptycount]);
             //attrnowrite;
             dif:=emptycount+baseskip;
             attrwrite(dif);
            end;
            if writeatr then begin
             dif:=atr[chry,chrx]-1;
             if dif>55 then dec(dif,9);
             if(writestand)then inc(dif,110);
             attrwrite(dif);
            end;
           end; // /    
           emptycount:=0;
      end //not c16on
      else begin //c16on
          sortpointer[psort]:=ppresave; sortdif[psort]:=dif; inc(psort);
          presave[ppresave]:=chry; inc(ppresave);
          presave[ppresave]:=chrx; inc(ppresave);
          for i:=0 to 3 do for j:=0 to 7 do begin
           dif:=ms[j,i+i]; dif0:=ms[j,i+i+1]; //L,R
           presave[ppresave]:=(dif and 7)+(dif0 and 7)shl 3+(dif and 8)shl 3+(dif0 and 8)shl 4; //%RLRRRLLL
           inc(ppresave);
          end;
          for j:=0 to 7 do for i:=0 to 7 do begin
           bx[chry*8+j,chrx*8+i]:=bs[j,i]; //   (*x - ..)
           gx[chry*8+j,chrx*8+i]:=gs[j,i];
           rx[chry*8+j,chrx*8+i]:=rs[j,i];
          end;
      end; //c16on
     end //    ( )
     else inc(emptycount); //
   end; //yx

{      label15.caption:=
      'gooderrorlevel='+inttostr(gooderrorlevel);
      //'average framesize='+floattostr(mem/realfr);
      memo1.lines.add('g.er.lev.='+inttostr(gooderrorlevel));
      label16.caption:=
      'tvideo-tsound='+floattostr(((chs+sts)-(maxchrs)*fr)/maxchrs);
      //'nonstandards/frame='+floattostr(chs/realfr);
      memo1.lines.add('tvid-tsnd='+floattostr(((chs+sts)-(maxchrs)*fr)/maxchrs));
      memo1.lines.add('psort='+floattostr(psort));}
   if not c16on then begin
        attrnowrite;
        if emptycount>0 then begin
         inc(holesstat[emptycount]);
         if bronly0>bronly1
         then dif:=255 // / 
         else dif:=emptycount+baseskip;
         attrwrite(dif); //   
        end;
   end //not c16on
   else begin //c16on // ,    
        wassortdif:=sortdif;
        curmaxchrs:=7777{maxchrs};
        chsinthisframe:=0;
        if (fr>2) then begin
          tvid_tsnd:=((chs+sts)-(maxchrs)*fr)/maxchrs;
          if (tvid_tsnd>2) and (psort>maxchrs)
          then begin
           curmaxchrs:=0; // , .. 
           memo1.lines.add('SKIPPED!');
          end;
          if (tvid_tsnd>1) or ((tvid_tsnd>-1)and(psort>maxchrs))
          then begin
  //         dividing:=false;
           sterrorlevel:=sterrorlevel*2;
           baderrorlevel:=baderrorlevel*2;
           gooderrorlevel:=gooderrorlevel*2;
           if sterrorlevel=0 then sterrorlevel:=1;
           if baderrorlevel=0 then baderrorlevel:=1;
           if gooderrorlevel=0 then gooderrorlevel:=1;
           //alwaysgood:=false;
           val(edsterrorlevel.Text,rreal,code);
           if sterrorlevel>rreal then sterrorlevel:=trunc(rreal);
           val(edbaderrorlevel.Text,rreal,code);
           if baderrorlevel>rreal then baderrorlevel:=trunc(rreal);
           val(edgooderrorlevel.Text,rreal,code);
           if gooderrorlevel>rreal then gooderrorlevel:=trunc(rreal);
          end;
          if ((tvid_tsnd<=0)and(psort<maxchrs)) or (tvid_tsnd<=-1)
          then begin
           //alwaysgood:=true;
  //         dividing:=true;
           sterrorlevel:=sterrorlevel div 2;
           baderrorlevel:=baderrorlevel div 2;
           gooderrorlevel:=gooderrorlevel div 2;
          end;
        end;

        for bplane:=0 to 1 do begin
          wr1st_chr_of_frame:=true;
          sortdif:=wassortdif;
          for loopn:=1 to psort do begin
           mindif:=sortdif[0];j:=0;
           for loopi:=0 to psort-1 do
            if sortdif[loopi]<mindif then begin mindif:=sortdif[loopi];j:=loopi;end;
           sortdif[j]:=MaxInt; //      sortdif
           chry:=presave[sortpointer[j]];
           chrx:=presave[sortpointer[j]+1];
           //     dif=0,     maxchrs*2 
           //(..   ,   !)
           if ((curmaxchrs<>0)and((mindif<>0)or(loopn>psort-2*maxchrs)))or(old[chry,chrx]=-100) then begin //  curmaxchrs   
            //
            if(mem mod (2048*sectcycl))=0 then for i:=0 to 2047 do bytewrite(wlockread(fwav));
            //plane0
            bytewrite(chry+bplane*64+128*ord(wr1st_chr_of_frame));
            wr1st_chr_of_frame:=false;
            bytewrite(chrx);
            gdechr:=sortpointer[j]+8*bplane;
            for ppresave:=gdechr+2 to gdechr+9 do bytewrite(presave[ppresave]);
            //plane2
            for ppresave:=gdechr+18 to gdechr+25 do bytewrite(presave[ppresave]);
            if bplane=1 then begin
              inc(chs); inc(chsinthisframe);
              old[chry,chrx]:=fr;
              for j:=0 to 7 do begin
// temptime:=timegettime;
               p:=bmpScanLine[chry*8+j];
               p0:=scr0ScanLine[chry*8+j];
// componentstime:=componentstime+timegettime-temptime;
               for i:=0 to 23 do p0[chrx*24+i]:=p[chrx*24+i];
               for i:=0 to 7 do begin
                oldbx[chry*8+j,chrx*8+i]:=bx[chry*8+j,chrx*8+i];
                oldgx[chry*8+j,chrx*8+i]:=gx[chry*8+j,chrx*8+i];
                oldrx[chry*8+j,chrx*8+i]:=rx[chry*8+j,chrx*8+i];
               end;
              end;
            end; //bplane=0
             // 
            if(mem and 2047)=2034
            then begin
{             gdechr:=filesize(fbyte);
             if ((filesize(fbyte)+mywritebufpointer)and 2047)<>2034
             then begin
               memo1.lines.Add('mem='+inttostr(mem));
               memo1.lines.Add('mywritebufpointer='+inttostr(mywritebufpointer));
             end;}
             for i:=0 to 13 do bytewrite(dif);
            end;
           end // 
          end; //loopn
        end; //bplane
   end; //c16on
filetime:=filetime+timegettime-temptime2;

// Memo1.Lines.Add('scan.time='+IntToStr(timeGetTime-oldtime));
// oldtime:=timeGetTime;

   if c16on then begin
        if(chsinthisframe>0) then begin // 
 temptime:=timegettime;
         if cbVisual.Checked then Image4.Picture.Bitmap.Assign(scr0);
         scr0.Assign(scr1); scr1.Assign(Image4.Picture.Bitmap); //scr0 -  
         oldatr2:=old; old:=old1; old1:=oldatr2; //old[chry,chrx] -   
         bx:=oldbx; oldbx:=oldbx1; oldbx1:=bx;//old*chrx -     (    )
         rx:=oldrx; oldrx:=oldrx1; oldrx1:=rx;
         gx:=oldgx; oldgx:=oldgx1; oldgx1:=gx;
         inc(fr);
         inc(realfr);
 visualtime:=visualtime+timegettime-temptime;
        end
        else begin // 
    //     Image4.Picture.Bitmap.Assign(scr1); //!!! ..     !
         inc(fr);
        end;
   end
   else begin //not c16on
        if cbVisual.Checked then Image4.Picture.Bitmap.Assign(scr0);
        inc(fr);
        inc(realfr);
   end;

   if realfr>0 then begin
 temptime:=timegettime;
    if cbVisual.Checked then begin
      Label1.caption:='bytes total='+inttostr(mem);
      //label17.caption:='standards/frame='+floattostr(sts/realfr);
      label17.caption:='chrs/idealframe='+floattostr(chs/fr);
    end;
    lbFrame.caption:='frames='+inttostr(realfr)+'(frame #'+inttostr(no)+')';
 visualtime:=visualtime+timegettime-temptime;
   end;
  frameexist:=true;
 end //FileExist
 else frameexist:=false;
temptime:=timegettime;
 myflush;
filetime:=filetime+timegettime-temptime;
 conversiontime:=conversiontime+timeGetTime-oldtime;
 making:=false;
end;

procedure TForm1.edSat1Change_pp;
var
 r:real;
 code:integer;
begin
 val(edsat1.Text,r,code); if code=0 then sat1:=r;
 val(edbri1.Text,r,code); if code=0 then bri1:=r;
 val(edcon1.Text,r,code); if code=0 then con1:=r;
 val(edstandartize.Text,r,code); if code=0 then standartize:=trunc(r);
 val(edsterrorlevel.Text,r,code); if code=0 then sterrorlevel:=trunc(r);
 val(edbaderrorlevel.Text,r,code); if code=0 then baderrorlevel:=trunc(r);
 val(edgooderrorlevel.Text,r,code); if code=0 then gooderrorlevel:=trunc(r);
 val(edbaddelay.Text,r,code); if code=0 then baddelay:=trunc(r);
 val(edgooddelay.Text,r,code); if code=0 then gooddelay:=trunc(r);
 val(edpixelsdelay.Text,r,code); if code=0 then pixelsdelay:=trunc(r);
 val(eddith.Text,r,code); if code=0 then begin n255:=byter(128+r*128);n0:=255-n255;end;
 val(edxmin.Text,r,code); if(code=0)and(r>=0)and(r<=maxx)then minx:=trunc(r);
 val(edxmax.Text,r,code); if(code=0)and(r>=minx)and(r<32)then maxx:=trunc(r);
 val(edymin.Text,r,code); if(code=0)and(r>=0)and(r<=maxy)then miny:=trunc(r);
 val(edymax.Text,r,code); if(code=0)and(r>=miny)and(r<32)then maxy:=trunc(r);
end;

procedure TForm1.edSat1Change(Sender: TObject);
begin
 edSat1Change_pp;
 if btStart.Enabled then begin openfiles; init; view; closefiles end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 if not making then begin
  view;
  if not frameexist
  then btStartClick(Sender) //stop
  else begin
   inc(no,frmstep);
   if no>frme then btStartClick(Sender) //stop
  end;
 end; //if not making
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 bmp.FreeImage;
 scr0.FreeImage;
end;

procedure TForm1.openfiles;
var
 buf:array[0..255]of byte;
begin
 assignFile(fwav,edWAV.Text); reset(fwav,1);  blockread(fwav,buf,$28);
 myreadbufpointer:=myreadbufsz;
 curquant:=0.0;
 assignFile(fbyte,'bytes');   rewrite(fbyte,1); {seek(fbyte,filesize(fbyte));}
 mem:=0;
 assignFile(fstand,'stands'); rewrite(fstand,1);{seek(fstand,filesize(fstand));}
 assignFile(fatr,'attrs');    rewrite(fatr,1);  {seek(fatr,filesize(fatr));}
end;

procedure TForm1.closefiles;
var
 i:integer;
begin
 mywritebufpointer:=0;
 //
 if(mem mod (2048*sectcycl))=0 then for i:=0 to 2047 do bytewrite(wlockread(fwav));
 //end of video
 bytewrite(255);
 myflush;
 CloseFile(fwav);
 CloseFile(fbyte);
 CloseFile(fstand);
 CloseFile(fatr);
end;

procedure TForm1.btStartClick(Sender: TObject);
var
 i,j,j2,k,y,col,total:integer;
begin
 if btStart.Enabled then begin
  for i:=0 to 255 do holesstat[i]:=0;
  memo1.Clear;
   pixtime:=0;
   conversiontime:=0;
   filetime:=0;
   componentstime:=0;
   visualtime:=0;
   britime:=0;
  openfiles; init;
  btStart.Enabled:=false; btStop.Enabled:=true;
  Timer1.Enabled:=true;
 end
 else begin
  Timer1.Enabled:=false;
  btStart.Enabled:=true; btStop.Enabled:=false;
  closefiles;
  if not cb16.Checked then begin
    assignFile(fbit,'bits'); rewrite(fbit,1);
    j:=0; j2:=0;
    total:=0;
    for i:=0 to mosts-1 do begin
     for k:=0 to 7 do blockwrite(fbit,most[i,k],1);
     memo1.Lines.add(inttostr(i)+':'+inttostr(mostuse[i])+'='+
     inttohex(most[i,0])+','+
     inttohex(most[i,1])+','+
     inttohex(most[i,2])+','+
     inttohex(most[i,3])+','+
     inttohex(most[i,4])+','+
     inttohex(most[i,5])+','+
     inttohex(most[i,6])+','+
     inttohex(most[i,7]));
     if(mostuse[i]>0)then inc(j);
     if(mostuse[i]>4)then inc(j2);
     inc(total,mostuse[i]);
    end;
    memo1.Lines.add('used standards: '+inttostr(j));
    memo1.Lines.add('>4 times used standards: '+inttostr(j2));
    CloseFile(fbit);
    //   
    j2:=0;
    for col:=0 to 15{31} do for y:=0 to 15 do begin
     image1.Canvas.Pen.Color:=0;
     image1.Canvas.MoveTo(col*5+4,y*5+4);
     image1.Canvas.LineTo(col*5+4,y*5);
     if total=0 then total:=1;
     perc:=mostuse[y+col*16{17}]/total;
     if (perc<0.0001)and(perc>0.0) then begin
      image1.Canvas.Pen.Color:=$ff7700;
      image1.Canvas.MoveTo(col*5+4,y*5+4);
      image1.Canvas.LineTo(col*5+4,y*5+trunc(0.0004*perc));
      inc(j2);
     end;
     if (mostuse[y+col*16{17}]<=8) then begin
      image1.Canvas.Pen.Color:=$1b00*(9-mostuse[y+col*16{17}]);
      image1.Canvas.MoveTo(col*5+4,y*5+4);
      image1.Canvas.LineTo(col*5+4,y*5);
      inc(j2);
     end;
    end;
    memo1.Lines.add('<0.1% used standards: '+inttostr(j2));
  end; //not c16on
  Memo1.Lines.Add('conversiontime='+IntToStr(conversiontime));
  Memo1.Lines.Add('filetime='+IntToStr(filetime));
  Memo1.Lines.Add('componentstime='+IntToStr(componentstime));
  Memo1.Lines.Add('visualtime='+IntToStr(visualtime));
  Memo1.Lines.Add('britime='+IntToStr(britime));
  Memo1.Lines.Add('pixtime='+IntToStr(pixtime));
  for i:=0 to 255 do Memo1.Lines.Add('holesstat['+IntToStr(i)+']='+IntToStr(holesstat[i]));
 end;
end;

procedure TForm1.edPathChange(Sender: TObject);
begin
 btApplyPath.Enabled:=true
end;

procedure TForm1.btApplyPathClick(Sender: TObject);
begin
 files:=edPath.Text;
 edWAV.Text:=files+'.wav';
 openfiles; init; view; closefiles; //   !
 btApplyPath.Enabled:=false
end;

procedure TForm1.edPathKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key=13 then btApplyPathClick(Sender);
end;

procedure TForm1.edFrmStepChange_pp;
var
 r:real;
 code:integer;
begin
 val(edfrmb.Text,r,code); if code=0 then frmb:=trunc(r);
 val(edfrme.Text,r,code); if code=0 then frme:=trunc(r);
 val(edfrmstep.Text,r,code); if code=0 then frmstep:=trunc(r);
end;

procedure TForm1.edFrmStepChange(Sender: TObject);
begin
 edFrmStepChange_pp;
 if btStart.Enabled then begin openfiles; init; view; closefiles end;
end;

end.
